HIP: Heterogenous-computing Interface for Portability: Device Management

HIP: Heterogenous-computing Interface for Portability

Functions
Device Management
HIP API

This section describes the device management functions of HIP runtime API. More...

Collaboration diagram for Device Management:

## Functions
hipError_t | hipDeviceSynchronize (void)
| Waits on all active streams on current device. More...
hipError_t | hipDeviceReset (void)
| The state of current device is discarded and updated to a fresh state. More...
hipError_t | hipSetDevice (int deviceId)
| Set default device to be used for subsequent hip API calls from this thread. More...
hipError_t | hipGetDevice (int *deviceId)
| Return the default device id for the calling host thread. More...
hipError_t | hipGetDeviceCount (int *count)
| Return number of compute-capable devices. More...
hipError_t | hipDeviceGetAttribute (int *pi, hipDeviceAttribute_t attr, int deviceId)
| Query for a specific device attribute. More...
hipError_t | hipGetDeviceProperties (hipDeviceProp_t *prop, int deviceId)
| Returns device properties. More...
hipError_t | hipDeviceSetCacheConfig (hipFuncCache_t cacheConfig)
| Set L1/Shared cache partition. More...
hipError_t | hipDeviceGetCacheConfig (hipFuncCache_t *cacheConfig)
| Set Cache configuration for a specific function. More...
hipError_t | hipDeviceGetLimit (size_t *pValue, enum hipLimit_t limit)
| Get Resource limits of current device. More...
hipError_t | hipDeviceGetSharedMemConfig (hipSharedMemConfig *pConfig)
| Returns bank width of shared memory for current device. More...
hipError_t | hipGetDeviceFlags (unsigned int *flags)
| Gets the flags set for current device. More...
hipError_t | hipDeviceSetSharedMemConfig (hipSharedMemConfig config)
| The bank width of shared memory on current device is set. More...
hipError_t | hipSetDeviceFlags (unsigned flags)
| The current device behavior is changed according the flags passed. More...
hipError_t | hipChooseDevice (int *device, const hipDeviceProp_t *prop)
| Device which matches hipDeviceProp_t is returned. More...
hipError_t | hipExtGetLinkTypeAndHopCount (int device1, int device2, uint32_t *linktype, uint32_t *hopcount)
| Returns the link type and hop count between two devices. More...
hipError_t | hipIpcGetMemHandle (hipIpcMemHandle_t *handle, void *devPtr)
| Gets an interprocess memory handle for an existing device memory allocation. More...
hipError_t | hipIpcOpenMemHandle (void **devPtr, hipIpcMemHandle_t handle, unsigned int flags)
| Opens an interprocess memory handle exported from another process and returns a device pointer usable in the local process. More...
hipError_t | hipIpcCloseMemHandle (void *devPtr)
| Close memory mapped with hipIpcOpenMemHandle. More...
hipError_t | hipIpcGetEventHandle (hipIpcEventHandle_t *handle, hipEvent_t event)
| Gets an opaque interprocess handle for an event. More...
hipError_t | hipIpcOpenEventHandle (hipEvent_t *event, hipIpcEventHandle_t handle)
| Opens an interprocess event handles. More...

## Detailed Description

This section describes the device management functions of HIP runtime API.

## Function Documentation

## ◆ hipChooseDevice()

hipError_t hipChooseDevice | ( | int * | device,
|  | const hipDeviceProp_t * | prop
| ) |  |

Device which matches hipDeviceProp_t is returned.

Parameters

  [out] | device | ID
  [in] | device | properties pointer

Returns
  hipSuccess, hipErrorInvalidValue

## ◆ hipDeviceGetAttribute()

hipError_t hipDeviceGetAttribute | ( | int * | pi,
|  | hipDeviceAttribute_t | attr,
|  | int | deviceId
| ) |  |

Query for a specific device attribute.

Parameters

  [out] | pi | pointer to value to return
  [in] | attr | attribute to query
  [in] | deviceId | which device to query for information

Returns
  hipSuccess, hipErrorInvalidDevice, hipErrorInvalidValue

## ◆ hipDeviceGetCacheConfig()

hipError_t hipDeviceGetCacheConfig | ( | hipFuncCache_t * | cacheConfig | ) |

Set Cache configuration for a specific function.

Parameters

  [in] | cacheConfig |

Returns
  hipSuccess, #hipErrorNotInitialized Note: AMD devices and some Nvidia GPUS do not support reconfigurable cache. This hint is ignored on those architectures.

## ◆ hipDeviceGetLimit()

hipError_t hipDeviceGetLimit | ( | size_t * | pValue,
|  | enum hipLimit_t | limit
| ) |  |

Get Resource limits of current device.

Parameters

  [out] | pValue |
  [in] | limit |

Returns
  hipSuccess, #hipErrorUnsupportedLimit, hipErrorInvalidValue Note: Currently, only hipLimitMallocHeapSize is available

## ◆ hipDeviceGetSharedMemConfig()

hipError_t hipDeviceGetSharedMemConfig | ( | hipSharedMemConfig * | pConfig | ) |

Returns bank width of shared memory for current device.

Parameters

  [out] | pConfig |

Returns
  hipSuccess, hipErrorInvalidValue, #hipErrorNotInitialized

Note: AMD devices and some Nvidia GPUS do not support shared cache banking, and the hint is ignored on those architectures.

## ◆ hipDeviceReset()

hipError_t hipDeviceReset | ( | void |  | ) |

The state of current device is discarded and updated to a fresh state.

Calling this function deletes all streams created, memory allocated, kernels running, events created. Make sure that no other thread is using the device or streams, memory, kernels, events associated with the current device.

Returns
  hipSuccess

See also
  hipDeviceSynchronize

## ◆ hipDeviceSetCacheConfig()

hipError_t hipDeviceSetCacheConfig | ( | hipFuncCache_t | cacheConfig | ) |

Set L1/Shared cache partition.

Parameters

  [in] | cacheConfig |

Returns
  hipSuccess, #hipErrorNotInitialized Note: AMD devices and some Nvidia GPUS do not support reconfigurable cache. This hint is ignored on those architectures.

## ◆ hipDeviceSetSharedMemConfig()

hipError_t hipDeviceSetSharedMemConfig | ( | hipSharedMemConfig | config | ) |

The bank width of shared memory on current device is set.

Parameters

  [in] | config |

Returns
  hipSuccess, hipErrorInvalidValue, #hipErrorNotInitialized

Note: AMD devices and some Nvidia GPUS do not support shared cache banking, and the hint is ignored on those architectures.

## ◆ hipDeviceSynchronize()

hipError_t hipDeviceSynchronize | ( | void |  | ) |

Waits on all active streams on current device.

When this command is invoked, the host thread gets blocked until all the commands associated with streams associated with the device. HIP does not support multiple blocking modes (yet!).

Returns
  hipSuccess

See also
  hipSetDevice, hipDeviceReset

## ◆ hipExtGetLinkTypeAndHopCount()

hipError_t hipExtGetLinkTypeAndHopCount | ( | int | device1,
|  | int | device2,
|  | uint32_t * | linktype,
|  | uint32_t * | hopcount
| ) |  |

Returns the link type and hop count between two devices.

Parameters

  [in] | device1 | Ordinal for device1
  [in] | device2 | Ordinal for device2
  [out] | linktype | Returns the link type (See hsa_amd_link_info_type_t) between the two devices
  [out] | hopcount | Returns the hop count between the two devices

Queries and returns the HSA link type and the hop count between the two specified devices.

Returns
  hipSuccess, #hipInvalidDevice, hipErrorRuntimeOther

## ◆ hipGetDevice()

hipError_t hipGetDevice | ( | int * | deviceId | ) |

Return the default device id for the calling host thread.

Parameters

  [out] | device | *device is written with the default device

HIP maintains an default device for each thread using thread-local-storage. This device is used implicitly for HIP runtime APIs called by this thread. hipGetDevice returns in * `device` the default device for the calling host thread.

Returns
  hipSuccess, hipErrorInvalidDevice, hipErrorInvalidValue

See also
  hipSetDevice, hipGetDevicesizeBytes

## ◆ hipGetDeviceCount()

hipError_t hipGetDeviceCount | ( | int * | count | ) |

Return number of compute-capable devices.

Parameters

  [output] | count Returns number of compute-capable devices.

Returns
  hipSuccess, hipErrorNoDevice

Returns in `*count` the number of devices that have ability to run compute commands. If there are no such devices, then hipGetDeviceCount will return hipErrorNoDevice. If 1 or more devices can be found, then hipGetDeviceCount returns hipSuccess.

## ◆ hipGetDeviceFlags()

hipError_t hipGetDeviceFlags | ( | unsigned int * | flags | ) |

Gets the flags set for current device.

Parameters

  [out] | flags |

Returns
  hipSuccess, hipErrorInvalidDevice, hipErrorInvalidValue

## ◆ hipGetDeviceProperties()

hipError_t hipGetDeviceProperties | ( | hipDeviceProp_t * | prop,
|  | int | deviceId
| ) |  |

Returns device properties.

Parameters

  [out] | prop | written with device properties
  [in] | deviceId | which device to query for information

Returns
  hipSuccess, hipErrorInvalidDevice

Populates hipGetDeviceProperties with information for the specified device.

## ◆ hipIpcCloseMemHandle()

hipError_t hipIpcCloseMemHandle | ( | void * | devPtr | ) |

Close memory mapped with hipIpcOpenMemHandle.

Unmaps memory returnd by hipIpcOpenMemHandle. The original allocation in the exporting process as well as imported mappings in other processes will be unaffected.

Any resources used to enable peer access will be freed if this is the last mapping using them.

Parameters

  devPtr | - Device pointer returned by hipIpcOpenMemHandle

Returns
  hipSuccess, hipErrorMapFailed, hipErrorInvalidHandle,

## ◆ hipIpcGetEventHandle()

hipError_t hipIpcGetEventHandle | ( | hipIpcEventHandle_t * | handle,
|  | hipEvent_t | event
| ) |  |

Gets an opaque interprocess handle for an event.

This opaque handle may be copied into other processes and opened with cudaIpcOpenEventHandle. Then cudaEventRecord, cudaEventSynchronize, cudaStreamWaitEvent and cudaEventQuery may be used in either process. Operations on the imported event after the exported event has been freed with hipEventDestroy will result in undefined behavior.

Parameters

  [out] | handle | Pointer to cudaIpcEventHandle to return the opaque event handle
  [in] | event | Event allocated with cudaEventInterprocess and cudaEventDisableTiming flags

Returns
  hipSuccess, #hipErrorInvalidConfiguration, hipErrorInvalidValue

## ◆ hipIpcGetMemHandle()

hipError_t hipIpcGetMemHandle | ( | hipIpcMemHandle_t * | handle,
|  | void * | devPtr
| ) |  |

Gets an interprocess memory handle for an existing device memory allocation.

Takes a pointer to the base of an existing device memory allocation created with hipMalloc and exports it for use in another process. This is a lightweight operation and may be called multiple times on an allocation without adverse effects.

If a region of memory is freed with hipFree and a subsequent call to hipMalloc returns memory with the same device address, hipIpcGetMemHandle will return a unique handle for the new memory.

Parameters

  handle | - Pointer to user allocated hipIpcMemHandle to return the handle in.
  devPtr | - Base pointer to previously allocated device memory

Returns
  hipSuccess, hipErrorInvalidHandle, hipErrorOutOfMemory, hipErrorMapFailed,

## ◆ hipIpcOpenEventHandle()

hipError_t hipIpcOpenEventHandle | ( | hipEvent_t * | event,
|  | hipIpcEventHandle_t | handle
| ) |  |

Opens an interprocess event handles.

Opens an interprocess event handle exported from another process with cudaIpcGetEventHandle. The returned hipEvent_t behaves like a locally created event with the hipEventDisableTiming flag specified. This event need be freed with hipEventDestroy. Operations on the imported event after the exported event has been freed with hipEventDestroy will result in undefined behavior. If the function is called within the same process where handle is returned by hipIpcGetEventHandle, it will return hipErrorInvalidContext.

Parameters

  [out] | event | Pointer to hipEvent_t to return the event
  [in] | handle | The opaque interprocess handle to open

Returns
  hipSuccess, hipErrorInvalidValue, hipErrorInvalidContext

## ◆ hipIpcOpenMemHandle()

hipError_t hipIpcOpenMemHandle | ( | void ** | devPtr,
|  | hipIpcMemHandle_t | handle,
|  | unsigned int | flags
| ) |  |

Opens an interprocess memory handle exported from another process and returns a device pointer usable in the local process.

Maps memory exported from another process with hipIpcGetMemHandle into the current device address space. For contexts on different devices hipIpcOpenMemHandle can attempt to enable peer access between the devices as if the user called hipDeviceEnablePeerAccess. This behavior is controlled by the hipIpcMemLazyEnablePeerAccess flag. hipDeviceCanAccessPeer can determine if a mapping is possible.

Contexts that may open hipIpcMemHandles are restricted in the following way. hipIpcMemHandles from each device in a given process may only be opened by one context per device per other process.

Memory returned from hipIpcOpenMemHandle must be freed with hipIpcCloseMemHandle.

Calling hipFree on an exported memory region before calling hipIpcCloseMemHandle in the importing context will result in undefined behavior.

Parameters

  devPtr | - Returned device pointer
  handle | - hipIpcMemHandle to open
  flags | - Flags for this operation. Must be specified as hipIpcMemLazyEnablePeerAccess

Returns
  hipSuccess, hipErrorMapFailed, hipErrorInvalidHandle, hipErrorTooManyPeers

Note
  No guarantees are made about the address returned in `*devPtr`. In particular, multiple processes may not receive the same address for the same `handle`.

## ◆ hipSetDevice()

hipError_t hipSetDevice | ( | int | deviceId | ) |

Set default device to be used for subsequent hip API calls from this thread.

Parameters

  [in] | deviceId | Valid device in range 0...hipGetDeviceCount().

Sets `device` as the default device for the calling host thread. Valid device id's are 0... (hipGetDeviceCount()-1).

Many HIP APIs implicitly use the "default device" :

- Any device memory subsequently allocated from this host thread (using hipMalloc) will be allocated on device.
- Any streams or events created from this host thread will be associated with device.
- Any kernels launched from this host thread (using hipLaunchKernel) will be executed on device (unless a specific stream is specified, in which case the device associated with that stream will be used).

This function may be called from any host thread. Multiple host threads may use the same device. This function does no synchronization with the previous or new device, and has very little runtime overhead. Applications can use hipSetDevice to quickly switch the default device before making a HIP runtime call which uses the default device.

The default device is stored in thread-local-storage for each thread. Thread-pool implementations may inherit the default device of the previous thread. A good practice is to always call hipSetDevice at the start of HIP coding sequency to establish a known standard device.

Returns
  hipSuccess, hipErrorInvalidDevice, #hipErrorDeviceAlreadyInUse

See also
  hipGetDevice, hipGetDeviceCount

## ◆ hipSetDeviceFlags()

hipError_t hipSetDeviceFlags | ( | unsigned | flags | ) |

The current device behavior is changed according the flags passed.

Parameters

  [in] | flags | The schedule flags impact how HIP waits for the completion of a command running on a device. hipDeviceScheduleSpin : HIP runtime will actively spin in the thread which submitted the work until the command completes. This offers the lowest latency, but will consume a CPU core and may increase power. hipDeviceScheduleYield : The HIP runtime will yield the CPU to system so that other tasks can use it. This may increase latency to detect the completion but will consume less power and is friendlier to other tasks in the system. hipDeviceScheduleBlockingSync : On ROCm platform, this is a synonym for hipDeviceScheduleYield. hipDeviceScheduleAuto : Use a hueristic to select between Spin and Yield modes. If the number of HIP contexts is greater than the number of logical processors in the system, use Spin scheduling. Else use Yield scheduling.

hipDeviceMapHost : Allow mapping host memory. On ROCM, this is always allowed and the flag is ignored. hipDeviceLmemResizeToMax :

Warning
  ROCm silently ignores this flag.

Returns
  hipSuccess, hipErrorInvalidDevice, #hipErrorSetOnActiveProcess